var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var YW;
(function (YW) {
    var API_URL = 'https://api.game.chot.cn/';
    var APPID = 'AEGs8dimDh8';
    var GAME_VERSION = '2.0.9';
    var ALIAS = 'oppoapp'; // 头条：toutiao; 微信：wx;  OPPO: oppo; VIVO: vivo ; 华为: huawei ; Oppo APP：oppoapp ; Vivo APP app：vivoapp
    var DEBUG = false;
    var VERSION = 1;
    // 默认数据配置
    var YwSdk_default = {
        slide: {},
        customise: {},
        switch: {},
        advertisement: {} // 广告
    };
    // tslint:disable-next-line:max-classes-per-file
    var YwSdk = /** @class */ (function () {
        function YwSdk(PlatformObj) {
            this.PlatformObj = PlatformObj;
            switch ((new YwSdk_config()).get_alias()) {
                case 'oppo':
                    this.PlatformSdk = new YwSdk_oppo(this.PlatformObj);
                    break;
                case 'huawei':
                    this.PlatformSdk = new YwSdk_huawei(this.PlatformObj);
                    break;
                case 'vivo':
                    this.PlatformSdk = new YwSdk_vivo(this.PlatformObj);
                    break;
                case 'toutiao':
                    this.PlatformSdk = new YwSdk_toutiao(this.PlatformObj);
                    break;
                case 'wx':
                    this.PlatformSdk = new YwSdk_wx(this.PlatformObj);
                    break;
                case 'qq':
                    this.PlatformSdk = new YwSdk_qq(this.PlatformObj);
                    break;
                case 'meizu':
                    this.PlatformSdk = new YwSdk_meizu(this.PlatformObj);
                    break;
                case 'oppoapp':
                    this.PlatformSdk = new YwSdk_Oppoapp(this.PlatformObj);
                    break;
                case 'vivoapp':
                    this.PlatformSdk = new YwSdk_Vivoapp(this.PlatformObj);
                    break;
                default:
                    console.log('平台信息错误');
                    break;
            }
        }
        /**
         * 注册回调函数
         * @param event 事件名称
         * @param __callback 回调函数
         * event = jump_out 小游戏跳转
         * event = on_show onshow
         */
        YwSdk.prototype.register_callback = function (event, __callback) {
            return this.PlatformSdk.register_callback(event, __callback);
        };
        /**
         * 跳出小游戏
         * @param obj
         * @param __callBack
         */
        YwSdk.prototype.jump_out = function (obj, __callBack) {
            if (__callBack === void 0) { __callBack = function (res) {
            }; }
            return this.PlatformSdk.jumpOut(obj, __callBack);
        };
        /**
         * 初始化APP
         * @param __callBack
         */
        YwSdk.prototype.init_app = function (__callBack) {
            return this.PlatformSdk.initApp(__callBack);
        };
        /**
         * 回到首屏
         */
        YwSdk.prototype.on_show = function (__callBack) {
            if (__callBack === void 0) { __callBack = function (res) {
            }; }
            return this.PlatformSdk.onShow(__callBack);
        };
        /**
         * 获取自定义配置
         */
        YwSdk.prototype.get_customise = function () {
            var customise = this.PlatformSdk.get_customise();
            if (customise.length > 0) {
                var _return_1 = [];
                customise.forEach(function (item, index, array) {
                    if (typeof item['type'] !== "undefined" && typeof item['value'] !== "undefined") {
                        switch (item['type']) {
                            case 3:
                                item['value'] = item['value'].replace(/\s*/g, "").split(',');
                                _return_1.push(item);
                                break;
                            default:
                                _return_1.push(item);
                                break;
                        }
                    }
                    else {
                        _return_1.push(item);
                    }
                });
                return _return_1;
            }
            else {
                return [];
            }
        };
        /**
         * 获取侧边栏
         */
        YwSdk.prototype.get_slide = function () {
            return this.PlatformSdk.get_slide();
        };
        YwSdk.prototype.get_token = function () {
            return this.PlatformSdk.get_token();
        };
        /**
         * 获取开关
         */
        YwSdk.prototype.get_switch = function () {
            return this.PlatformSdk.get_switch();
        };
        /**
         * 获取统计对象
         */
        YwSdk.prototype.get_statistic = function () {
            return this.PlatformSdk.getStatistic();
        };
        /**
         * 不需要登录直接初始化游戏
         */
        YwSdk.prototype.init_game = function (__callBack) {
            return this.PlatformSdk.init_game(__callBack);
        };
        return YwSdk;
    }());
    YW.YwSdk = YwSdk;
    // tslint:disable-next-line:max-classes-per-file class-name
    var YwSdk_config = /** @class */ (function () {
        function YwSdk_config() {
        }
        YwSdk_config.prototype.get_apiurl = function () {
            return API_URL;
        };
        YwSdk_config.prototype.get_appid = function () {
            return APPID;
        };
        YwSdk_config.prototype.get_game_version = function () {
            return GAME_VERSION;
        };
        YwSdk_config.prototype.get_version = function () {
            return VERSION;
        };
        YwSdk_config.prototype.get_alias = function () {
            return ALIAS;
        };
        YwSdk_config.prototype.get_debug = function () {
            return DEBUG;
        };
        return YwSdk_config;
    }());
    // tslint:disable-next-line:max-classes-per-file class-name
    var YwSdk_platform_base = /** @class */ (function () {
        function YwSdk_platform_base(PlatformObj) {
            this.PlatformObj = PlatformObj;
            this.SysConfig = new YwSdk_config();
            this.Storage = new YwSdk_storage('', this.PlatformObj);
            this.appid = this.SysConfig.get_appid();
            this.game_version = this.SysConfig.get_game_version();
            this.alias = this.SysConfig.get_alias();
            this.api_url = this.SysConfig.get_apiurl();
            this.debug = this.SysConfig.get_debug();
            this.version = this.SysConfig.get_version();
            this.__callback = {};
            // this.onShow(function () {
            // });
            this.Statistic = new Statistic(this.SysConfig.get_appid(), 1);
        }
        YwSdk_platform_base.prototype.register_callback = function (event, __callBack) {
            this.__callback[event] = __callBack;
        };
        YwSdk_platform_base.prototype.run_callback = function (event, res) {
            console.log('call_type', typeof this.__callback[event]);
            if (typeof this.__callback[event] == 'function') {
                this.__callback[event](res);
            }
        };
        YwSdk_platform_base.prototype.get_customise = function () {
            if (this.Storage.get('server_init_customise') === undefined || !this.Storage.get('server_init_customise')) {
                return YwSdk_default.customise;
            }
            else {
                return this.Storage.get('server_init_customise');
            }
        };
        YwSdk_platform_base.prototype.get_advertisement = function () {
            if (this.Storage.get('server_init_advertisement') === undefined || !this.Storage.get('server_init_advertisement')) {
                return YwSdk_default.advertisement;
            }
            else {
                return this.Storage.get('server_init_advertisement');
            }
        };
        YwSdk_platform_base.prototype.get_slide = function () {
            if (this.Storage.get('server_init_slide') === undefined || !this.Storage.get('server_init_slide')) {
                return YwSdk_default.slide;
            }
            else {
                return this.Storage.get('server_init_slide');
            }
        };
        YwSdk_platform_base.prototype.get_switch = function () {
            if (this.Storage.get('server_init_switch') === undefined || !this.Storage.get('server_init_switch')) {
                return YwSdk_default.switch;
            }
            else {
                return this.Storage.get('server_init_switch');
            }
        };
        YwSdk_platform_base.prototype.get_token = function () {
            if (this.Storage.get('server_init_token', true) === undefined || !this.Storage.get('server_init_token', true)) {
                return '';
            }
            else {
                return this.Storage.get('server_init_token', true);
            }
        };
        YwSdk_platform_base.prototype.getStatistic = function () {
            return this.Statistic;
        };
        YwSdk_platform_base.prototype.initApp = function (__callBack) {
            this.console_log('开始初始化应用');
            var sdk = this;
            var launch = sdk.getLaunchOptionsSyncData();
            sdk.console_log('获取启动参数', launch);
            if (!this.get_token()) {
                var method = function (_obj) {
                    sdk.console_log('初始化应用成功', _obj);
                    sdk.start(launch);
                    sdk.console_log('调用启动参数成功');
                    var init_data = {
                        token: sdk.get_token(),
                        customise: sdk.get_customise(),
                        slide: sdk.get_slide(),
                        switch: sdk.get_switch()
                    };
                    sdk.console_log('init_data : ', init_data);
                    __callBack(_obj);
                    sdk.run_callback('init_app', _obj);
                };
                this.console_log('开始调用登录方法');
                this.login(method);
            }
            else {
                this.console_log('没有登录，开始调用启动方法');
                this.start(launch);
            }
        };
        YwSdk_platform_base.prototype.jumpOut = function (obj, __callBack) {
            this.console_log('执行jump_out方法');
            var sdk = this;
            var data = {
                token: this.get_token(),
                to_appid: obj['toAppid'],
                _id: obj['_id']
            };
            this._ajax({
                data: this.build_data('statistic.jump_out', data),
                success: function (obj) {
                    __callBack(obj);
                    sdk.run_callback('jump_out', obj);
                    sdk.console_log('调用jump_out成功', obj);
                },
                error: function (obj) {
                    sdk.console_log('调用jump_out失败', obj);
                }
            });
        };
        YwSdk_platform_base.prototype.onShow = function (__callBack) {
            this.console_log('执行onShow方法');
            var sdk = this;
            var method = function (res) {
                sdk.console_log('获取到解析后的onShow数据', res);
                sdk.start(res);
                sdk.console_log('发送数据到服务器成功,开始调用回调函数');
                __callBack(res);
                sdk.run_callback('on_show', res);
            };
            this.getOnShowData(method);
        };
        YwSdk_platform_base.prototype.start = function (obj, __callBack) {
            if (obj === void 0) { obj = {}; }
            if (__callBack === void 0) { __callBack = function (res) {
            }; }
            this.console_log('执行start方法');
            var sdk = this;
            var data = obj;
            data['token'] = this.get_token();
            sdk.console_log('发送start数据', data);
            this._ajax({
                data: this.build_data('statistic.start', data),
                success: function (obj) {
                    sdk.console_log('调用start成功', obj);
                    __callBack(obj);
                },
                error: function (obj) {
                    sdk.console_log('调用start失败', obj);
                    __callBack(obj);
                }
            });
        };
        YwSdk_platform_base.prototype.init_game = function (__callBack) {
            this.console_log('执行init_game方法');
            var sdk = this;
            var data = {};
            this._ajax({
                data: this.build_data('game.init_app', data),
                success: function (res) {
                    sdk.console_log('调用init_game成功', res);
                    sdk.init_server_data(res.data);
                    sdk.console_log('初始化init_game成功');
                    __callBack(res.data);
                    sdk.console_log('调用init_game回调函数成功');
                },
                error: function (res) {
                    sdk.console_log('调用init_game失败', res);
                }
            });
        };
        YwSdk_platform_base.prototype.login_sys = function (data, __callBack, async) {
            if (async === void 0) { async = true; }
            this.console_log('进入login_sys方法');
            var sdk = this;
            // tslint:disable-next-line:no-parameter-reassignment
            data = this.build_data('user.login', data);
            sdk.console_log('login_sys登录参数', data);
            var obj = {
                data: data,
                error: function () {
                    sdk.console_log('登录失败');
                }
            };
            obj['success'] = function (res) {
                sdk.console_log('调用登录接口成功', res);
                sdk.console_log('初始化数据对象完成，开始调用回调');
                __callBack(res);
            };
            this._ajax(obj, async);
        };
        YwSdk_platform_base.prototype.build_data = function (action, data) {
            if (!action) {
                this.console_log('action 不能为空');
            }
            var operate = this.getOperate(action);
            data['operate'] = operate;
            data['appid'] = this.appid;
            data['send_time'] = Date.now();
            data['game_version'] = this.game_version;
            if (this.appid === '') {
                this.console_log('appid 不能为空');
            }
            if (this.game_version === '') {
                this.console_log('版本号 不能为空');
            }
            return data;
        };
        YwSdk_platform_base.prototype.init_server_data = function (_initData) {
            this.Storage.set('server_init_token', _initData['token'] === undefined ? '' : _initData['token']);
            this.Storage.set('server_init_customise', _initData['customise'] === undefined ? '' : _initData['customise']);
            this.Storage.set('server_init_advertisement', _initData['advertisement'] === undefined ? '' : _initData['advertisement']);
            this.Storage.set('server_init_slide', _initData['slide'] === undefined ? '' : _initData['slide']);
            this.Storage.set('server_init_switch', _initData['switch'] === undefined ? '' : _initData['switch']);
        };
        YwSdk_platform_base.prototype._ajax = function (obj, async, method) {
            if (async === void 0) { async = true; }
            if (method === void 0) { method = 'post'; }
            var data = obj.data;
            var sdk = this;
            if (typeof (data) === 'undefined') {
                return false;
            }
            var xhr = new XMLHttpRequest();
            if (async) {
                xhr.open(method, this.api_url, async); // 第三个参数决定是否采用异步的方式
            }
            else {
                xhr.open(method, this.api_url); // 第三个参数决定是否采用异步的方式
            }
            xhr.setRequestHeader('content-type', 'application/json');
            xhr.send(JSON.stringify(data));
            sdk.console_log('ajax发送的数据', obj.data);
            xhr.onreadystatechange = function () {
                sdk.console_log('状态', xhr.status);
                sdk.console_log('状态码', xhr.readyState);
                if (xhr.status === 200 && xhr.readyState === 4) {
                    if (typeof (obj.success) !== "undefined") {
                        var json = JSON.parse(xhr.responseText);
                        sdk.console_log('ajax接收到的数据', obj.data);
                        return obj.success(json);
                    }
                }
                else if (xhr.status !== 200) {
                    if (typeof (obj.error) !== undefined) {
                        sdk.console_log('获取数据异常', xhr);
                        return obj.error();
                    }
                }
                else {
                    sdk.console_log('请求数据错误', obj.data);
                }
            };
        };
        YwSdk_platform_base.prototype.console_log = function (title, data) {
            if (this.debug) {
                if (!data) {
                    console.log(title);
                }
                else {
                    console.log(title, data);
                }
            }
        };
        YwSdk_platform_base.prototype.getOperate = function (action) {
            return this.alias + "." + this.version + "." + action;
        };
        return YwSdk_platform_base;
    }());
    var Statistic = /** @class */ (function () {
        function Statistic(appid, user_id) {
            this.api_url = '';
            this.Game = {
                appid: appid,
                start_time: this.getTime(),
                last_click: '',
                last_level: 0,
                play_time: 0,
                user_id: user_id
            };
            this.PlayInfo = {
                start_time: this.getTime(),
                use_time: 0,
                status: 0,
            };
            this.Data = {};
            this.SendData = {
                game: this.Game,
            };
            // this.start_time = this.getTime();
            // this.Game.appid = this.appid = appid;
            // this.Game.start_time = this.start_time;
            // this.Game.user_id = user_id;
            // this.user_id = user_id;
        }
        Statistic.prototype.setCurrentLevel = function (level) {
            if (level === void 0) { level = 0; }
            this.Level = {
                appid: this.Game.appid,
                level_number: level,
                start_time: this.getTime(),
                play_count: 0,
                fail_count: 0,
                use_time: 0,
                user_id: this.Game.user_id,
            };
            this.current_level = this.Level;
            this.current_level.level_number = level;
            this.current_level.appid = this.appid;
            this.current_level.start_time = this.getTime();
            this.current_level.user_id = this.user_id;
            this.Game.last_level = level;
            this.Game.play_time = this.getUseTime(this.Game.start_time);
        };
        Statistic.prototype.getTime = function () {
            return Math.round(Date.now());
        };
        Statistic.prototype.getUseTime = function (start_time) {
            return Math.round(Date.now()) - start_time;
        };
        Statistic.prototype.start = function () {
            this.PlayInfo.start_time = this.getTime();
            this.PlayInfo.use_time = 0;
            this.PlayInfo.status = 0;
        };
        Statistic.prototype.click = function (event_id) {
            this.Game.last_click = this.Event.flag = event_id;
            this.Event.user_id = this.user_id;
            this.Event.click_count = 1;
            this.Event.click_time = this.getTime();
            this.current_level.event_list.push(this.Event);
        };
        Statistic.prototype.victory = function () {
            this.PlayInfo.use_time = this.getUseTime(this.PlayInfo.start_time);
            this.PlayInfo.status = 1;
            this.current_level.play_list.push(this.PlayInfo);
            this.current_level.play_count = this.current_level.play_list.length;
            this.Data.game = this.Game;
            this.Data.level_list.push(this.current_level);
        };
        Statistic.prototype.fail = function () {
            this.PlayInfo.use_time = this.getUseTime(this.PlayInfo.start_time);
            this.PlayInfo.status = 0;
            this.current_level.play_list.push(this.PlayInfo);
            this.current_level.play_count = this.current_level.play_list.length;
            this.current_level.fail_count = this.current_level.fail_count ? this.current_level.fail_count += 1 : 1;
        };
        Statistic.prototype.initData = function () {
        };
        Statistic.prototype.groupData = function () {
        };
        Statistic.prototype.quit = function () {
            console.log('quit data', {
                event: this.Event,
                level: this.Level,
                current: this.current_level,
            });
            this.send_data(function () {
            });
        };
        Statistic.prototype.deal_data = function () {
            this.SendData.game = this.Data.game;
            var level;
            var event;
            this.Data.level_list.forEach(function (value, index, array) {
                if (typeof level[value.level_number]) {
                }
                else {
                    level[value.level_number] = value;
                }
                if (value.event_list.length > 0) {
                    value.event_list.forEach(function (_v, _i, _a) {
                        if (typeof event[value.level_number] && typeof event[value.level_number][_v.flag]) {
                        }
                        else {
                            event[value.level_number][_v.flag] = _v;
                        }
                    });
                }
            });
        };
        Statistic.prototype.send_data = function (pre_deal_data) {
            var obj = this;
            pre_deal_data();
            this._ajax({
                data: this.Data,
                success: function (res) {
                    if (res.code) {
                        obj.initData();
                    }
                }
            });
        };
        Statistic.prototype._ajax = function (obj, async, method) {
            if (async === void 0) { async = true; }
            if (method === void 0) { method = 'post'; }
            var data = obj.data;
            if (typeof (data) === 'undefined') {
                return false;
            }
            var xhr = new XMLHttpRequest();
            if (async) {
                xhr.open(method, this.api_url, async); // 第三个参数决定是否采用异步的方式
            }
            else {
                xhr.open(method, this.api_url); // 第三个参数决定是否采用异步的方式
            }
            xhr.setRequestHeader('content-type', 'application/json');
            xhr.send(JSON.stringify(data));
            xhr.onreadystatechange = function () {
                if (xhr.status === 200 && xhr.readyState === 4) {
                    if (typeof (obj.success) !== "undefined") {
                        var json = JSON.parse(xhr.responseText);
                        return obj.success(json);
                    }
                }
                else if (xhr.status !== 200) {
                    if (typeof (obj.error) !== undefined) {
                        return obj.error();
                    }
                }
                else {
                }
            };
        };
        return Statistic;
    }());
    //统计end
    // tslint:disable-next-line:class-name max-classes-per-file
    var YwSdk_storage = /** @class */ (function () {
        function YwSdk_storage(storage_type, PlatformObj) {
            if (storage_type === void 0) { storage_type = ''; }
            this.storage_type = storage_type;
            this.data = {};
            this.PlatformObj = PlatformObj;
        }
        YwSdk_storage.prototype.type = function (type) {
            if (type === void 0) { type = 'session'; }
            this.storage_type = type;
            return this;
        };
        YwSdk_storage.prototype.set = function (name, value) {
            var _value = typeof (value) == 'string' ? value : JSON.stringify(value);
            switch (this.storage_type) {
                case 'session':
                    this.PlatformObj.sessionStorage.setItem(name, _value);
                    break;
                case 'local':
                    this.PlatformObj.localStorage.setItem(name, _value);
                    break;
                default:
                    this.data[name] = _value;
                    break;
            }
        };
        YwSdk_storage.prototype.get = function (name, dataIsString) {
            if (dataIsString === void 0) { dataIsString = false; }
            var _value;
            switch (this.storage_type) {
                case 'session':
                    _value = this.PlatformObj.sessionStorage.getItem(name);
                    break;
                case 'local':
                    _value = this.PlatformObj.localStorage.getItem(name);
                    break;
                default:
                    _value = this.data[name] === undefined ? '{}' : this.data[name];
                    break;
            }
            if (dataIsString) {
                _value = _value.toString();
                return _value === '{}' ? '' : _value;
            }
            else {
                return _value === '{}' ? '' : JSON.parse(_value);
            }
        };
        return YwSdk_storage;
    }());
    /**
     * qq,wx,toutiao
     * 平台登录方法：login
     * 平台返回凭据名称：code
     * 登录调用后台方式：异步
     */
    // tslint:disable-next-line:max-classes-per-file class-name
    var Base_1 = /** @class */ (function (_super) {
        __extends(Base_1, _super);
        function Base_1() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Base_1.prototype.getLaunchOptionsSyncData = function () {
            var options = this.PlatformObj.getLaunchOptionsSync();
            console.log('get启动参数', options);
            if (options) {
                // tslint:disable-next-line:no-unused-expression
                options.referrerInfo || (options.referrerInfo = {}); // 补全头条
            }
            if (options.referrerInfo !== undefined) {
                return {
                    launch: {
                        'path': options.path,
                        'scene': options.scene,
                        'query': options.query,
                        'referrerInfo_extraData': options.referrerInfo.extraData,
                        'referrerInfo_appId': options.referrerInfo.appId
                    }
                };
            }
        };
        Base_1.prototype.getOnShowData = function (__callBack) {
            if (__callBack === void 0) { __callBack = function (res) {
            }; }
            var sdk = this;
            this.PlatformObj.onShow(function (options) {
                console.log('show_options', options);
                var launch = {
                    'scene': options.scene,
                    'query': options.query
                };
                if (options.referrerInfo !== undefined) {
                    sdk.console_log('获取onShow数据成功', options);
                    launch['path'] = options.referrerInfo.path;
                    launch['referrerInfo_extraData'] = options.referrerInfo.extraData;
                    launch['referrerInfo_appId'] = options.referrerInfo.appId;
                }
                var data = {
                    launch: launch
                };
                __callBack(data);
            });
        };
        Base_1.prototype.login = function (__callBack) {
            var sdk = this;
            var options = this.PlatformObj.getLaunchOptionsSync();
            this.console_log('获取启动参数成功', options);
            this.PlatformObj.login({
                success: function (res) {
                    sdk.console_log('调用' + sdk.alias + '平台登录成功', res);
                    sdk.login_sys({ code: res.code }, function (res) {
                        sdk.console_log('开始初始化系统参数', res);
                        sdk.init_server_data(res.data.init);
                        __callBack(res.data.init);
                    }, true);
                },
                fail: function (res) {
                    sdk.init_game(__callBack);
                    console.log("调用平台登录失败", res);
                }
            });
        };
        return Base_1;
    }(YwSdk_platform_base));
    /**
     * oppo
     * 平台登录方法：login
     * 平台返回凭据名称：token
     * 调用后台方式：同步
     */
    // tslint:disable-next-line:max-classes-per-file class-name
    var Base_2 = /** @class */ (function (_super) {
        __extends(Base_2, _super);
        function Base_2() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Base_2.prototype.getLaunchOptionsSyncData = function () {
            return {
                launch: {}
            };
        };
        Base_2.prototype.getOnShowData = function (__callBack) {
            if (__callBack === void 0) { __callBack = function (res) {
            }; }
            var sdk = this;
            this.PlatformObj.onShow(function (options) {
                console.log('show_options', options);
                var launch = {};
                if (typeof options == 'object') {
                    var data = {
                        launch: launch
                    };
                    __callBack(data);
                }
            });
        };
        Base_2.prototype.login = function (__callBack) {
            var sdk = this;
            this.PlatformObj.login({
                success: function (res) {
                    sdk.console_log('调用' + sdk.alias + '平台登录成功', res);
                    sdk.login_sys({ token: res.token }, function (res) {
                        sdk.console_log('开始初始化系统参数', res);
                        sdk.init_server_data(res.data.init);
                        __callBack(res.data.init);
                    }, false);
                },
                fail: function (res) {
                    console.log("调用平台登录失败", res);
                }
            });
        };
        return Base_2;
    }(YwSdk_platform_base));
    /**
     * vivo
     * 平台登录方法：login
     * 平台返回凭据名称：token
     * 调用后台方式：异步
     */
    // tslint:disable-next-line:max-classes-per-file class-name
    var Base_3 = /** @class */ (function (_super) {
        __extends(Base_3, _super);
        function Base_3() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Base_3.prototype.getLaunchOptionsSyncData = function () {
            return {
                launch: {}
            };
        };
        Base_3.prototype.getOnShowData = function (__callBack) {
            if (__callBack === void 0) { __callBack = function (res) {
            }; }
            var sdk = this;
            this.PlatformObj.onShow(function (options) {
                console.log('show_options', options);
                var data = {
                    launch: {
                        'query': options.query.packageName,
                        'referrerInfo_extraData': options.referrerInfo.extraData,
                        'referrerInfo_package': options.referrerInfo.package
                    }
                };
                __callBack(data);
            });
        };
        Base_3.prototype.login = function (__callBack) {
            var sdk = this;
            this.PlatformObj.login({
                success: function (res) {
                    sdk.console_log('调用' + sdk.alias + '平台登录成功', res);
                    sdk.login_sys({ token: res.token }, function (res) {
                        sdk.console_log('开始初始化系统参数', res);
                        sdk.init_server_data(res.data.init);
                        __callBack(res.data.init);
                    }, true);
                },
                fail: function (res) {
                    console.log("调用平台登录失败", res);
                }
            });
        };
        return Base_3;
    }(YwSdk_platform_base));
    /**
     * meizu
     * 平台登录方法：getToken
     * 平台返回凭据名称：token
     * 调用后台方式：同步
     */
    // tslint:disable-next-line:max-classes-per-file class-name
    var Base_4 = /** @class */ (function (_super) {
        __extends(Base_4, _super);
        function Base_4() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Base_4.prototype.getLaunchOptionsSyncData = function () {
            return {
                launch: {}
            };
        };
        Base_4.prototype.getOnShowData = function (__callBack) {
            if (__callBack === void 0) { __callBack = function (res) {
            }; }
            var sdk = this;
            this.PlatformObj.onShow(function (options) {
                console.log('show_options', options);
                var launch = {};
                if (options == undefined) {
                    var data = {
                        launch: launch
                    };
                    __callBack(data);
                }
            });
        };
        Base_4.prototype.login = function (__callBack) {
            var sdk = this;
            sdk.console_log('this.PlatformObj', this.PlatformObj);
            this.PlatformObj.getToken({
                success: function (res) {
                    sdk.console_log('调用' + sdk.alias + '平台登录成功', res);
                    sdk.login_sys({ token: res.token }, function (res) {
                        sdk.console_log('开始初始化系统参数', res);
                        sdk.init_server_data(res.data.init);
                        __callBack(res.data.init);
                    }, false);
                },
                fail: function (res) {
                    console.log("调用平台登录失败", res); //用户取消，调用游客登录模式
                    if (res.code == 4) {
                        sdk.PlatformObj.getIMEI({
                            success: function (res) {
                                sdk.console_log('调用' + sdk.alias + '平台设备号成功', res);
                                sdk.login_sys({ token: res.imei }, function (res) {
                                    sdk.console_log('开始初始化系统参数', res);
                                    sdk.init_server_data(res.data.init);
                                    __callBack(res.data.init);
                                }, false);
                            },
                            fail: function (res) {
                                console.log("调用平台设备号失败", res);
                            }
                        });
                    }
                }
            });
        };
        return Base_4;
    }(YwSdk_platform_base));
    // tslint:disable-next-line:max-classes-per-file class-name
    var YwSdk_wx = /** @class */ (function (_super) {
        __extends(YwSdk_wx, _super);
        function YwSdk_wx() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return YwSdk_wx;
    }(Base_1));
    // tslint:disable-next-line:max-classes-per-file class-name
    var YwSdk_toutiao = /** @class */ (function (_super) {
        __extends(YwSdk_toutiao, _super);
        function YwSdk_toutiao() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return YwSdk_toutiao;
    }(Base_1));
    // tslint:disable-next-line:max-classes-per-file class-name
    var YwSdk_qq = /** @class */ (function (_super) {
        __extends(YwSdk_qq, _super);
        function YwSdk_qq() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return YwSdk_qq;
    }(Base_1));
    // tslint:disable-next-line:max-classes-per-file class-name
    var YwSdk_meizu = /** @class */ (function (_super) {
        __extends(YwSdk_meizu, _super);
        function YwSdk_meizu() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return YwSdk_meizu;
    }(Base_4));
    // tslint:disable-next-line:max-classes-per-file class-name
    var YwSdk_oppo = /** @class */ (function (_super) {
        __extends(YwSdk_oppo, _super);
        function YwSdk_oppo() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return YwSdk_oppo;
    }(Base_2));
    // tslint:disable-next-line:max-classes-per-file class-name
    var YwSdk_vivo = /** @class */ (function (_super) {
        __extends(YwSdk_vivo, _super);
        function YwSdk_vivo() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return YwSdk_vivo;
    }(Base_3));
    // tslint:disable-next-line:max-classes-per-file class-name
    var YwSdk_huawei = /** @class */ (function (_super) {
        __extends(YwSdk_huawei, _super);
        function YwSdk_huawei() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return YwSdk_huawei;
    }(Base_2));
    // tslint:disable-next-line:max-classes-per-file class-name
    var YwSdk_Oppoapp = /** @class */ (function (_super) {
        __extends(YwSdk_Oppoapp, _super);
        function YwSdk_Oppoapp() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return YwSdk_Oppoapp;
    }(Base_2));
    // tslint:disable-next-line:max-classes-per-file class-name
    var YwSdk_Vivoapp = /** @class */ (function (_super) {
        __extends(YwSdk_Vivoapp, _super);
        function YwSdk_Vivoapp() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return YwSdk_Vivoapp;
    }(Base_2));
    /**
 * 功能开关控制器
 * */
    var SwitchManager = /** @class */ (function () {
        function SwitchManager() {
        }
        /**
         * 初始化数据， 网络传过来
         */
        SwitchManager.initData = function (data) {
            console.info(data);
            for (var i = 0; i < data.length; i++) {
                var item = data[i];
                this.setValue(item, item["name"]);
            }
            // GameData.hide_ray = this.show_radial == 0;
            // GameData.hide_gun = this.show_radial == 0;
        };
        SwitchManager.setValue = function (item, key) {
            this[key] = Number(item["value"]);
            // console.log("key:", key + "==" + Number(item["value"]))
            console.log("开关信息：" + key + ": " + this[key]);
        };
        /**
             *  【发行】开局试用皮肤
             */
        SwitchManager.showStartTry = function () {
            // Global.game_num++;
            // if (Global.game_num >= this.start_try_grade && (Global.game_num - this.start_try_grade) % this.start_try_grade_level == 0) {
            //     return true;
            // }
            return false;
        };
        /**
         * 点击关闭按钮跳转原生
         * @returns
         */
        SwitchManager.closeToNative = function () {
            // Global.close_to_native_num++;
            // if (this.close_to_native && CM.mainCH.adContent && Global.close_to_native_num % this.close_to_native == 0) {
            //     return true;
            // }
            return false;
        };
        SwitchManager.showNative = function () {
            // if (Laya.Browser.now() - Global.go_game_time < this.fist_screen_time || Laya.Browser.now() - this.interstitial_time < this.interval_screen_time) {
            //     return false;
            // }
            // if (CM.mainCH.adContent) {
            //     this.interstitial_time = Laya.Browser.now();
            //     return true;
            // } else {
            return false;
            // }
        };
        /**显示广告 */
        SwitchManager.showAd = function () {
            // if (Laya.Browser.now() - Global.go_game_time >= 60 * 1000 || this.show_ad_promptly) {
            //     return true;
            // }
            return false;
        };
        /**所有游戏界面banner是否显示，0是关，1是开 */
        SwitchManager.game_banner = 1;
        /*显示格子广告开关 */
        SwitchManager.show_grid = 0;
        /*显示原生广告开关 */
        SwitchManager.show_custom = 0;
        /* 原生广告开关 */
        SwitchManager.advertisement = 0;
        /**局内原生广告是否展示 */
        SwitchManager.advertisement_game = 0;
        /**局内原生广告是否展示 */
        SwitchManager.advertisement_game1 = 0;
        /**局内原生广告展示时间 */
        SwitchManager.ad_game_show_time = 5000;
        /**局内原生广告隐藏时间 */
        SwitchManager.ad_game_hide_time = 5000;
        /**显示桌面图标(图标)  */
        SwitchManager.show_shortcut = 0;
        /**游戏中是否显示原生模板广告 */
        SwitchManager.game_custom = 0;
        //是否立即显示广告（关闭后1分钟后显示）
        SwitchManager.show_ad_promptly = 0;
        /**点击关闭按钮跳转原生（0.关闭，1.每次，2.间隔1次） */
        SwitchManager.close_to_native = 0;
        /**九宫格广告开关 */
        SwitchManager.game_portal_ad = 0;
        /* 插屏广告显示间隔（1每关，2间隔1关） */
        SwitchManager.insertAd_level = 1;
        /************** VIVO APP 开关 ***************/
        /* 显示插屏开关 */
        SwitchManager.normal_screen = 1;
        /* 显示插屏开关(其他界面) */
        SwitchManager.normal_screen_other = 0;
        /* 显示插屏开关(暂停界面) */
        SwitchManager.normal_screen_pause = 0;
        /* 进游戏多长时间后可以显示插屏广告 */
        SwitchManager.fist_screen_time = 10 * 1000;
        /* 插屏广告间隔时间 */
        SwitchManager.interval_screen_time = 600 * 1000;
        /* 插屏广告延迟弹出 */
        SwitchManager.delay_screen_time = 700;
        /**点击大转盘直接看视频*/
        SwitchManager.is_turn_video = 0;
        /**开局试用皮肤开启关卡 */
        SwitchManager.start_try_grade = 1;
        /**开局试用皮肤间隔关卡 1为每关都开启*/
        SwitchManager.start_try_grade_level = 1;
        /**点击游戏中加号次数 */
        SwitchManager.click_num = 0;
        /**显示概率 */
        SwitchManager.show_ad_prob = 0;
        SwitchManager.interstitial_time = 0;
        return SwitchManager;
    }());
    YW.SwitchManager = SwitchManager;
    var YwTimer = /** @class */ (function () {
        function YwTimer() {
        }
        // 记录当前时间
        YwTimer.recordADBanner = function () {
            YwTimer.timerADBanner = new Date().getTime();
        };
        YwTimer.recordADInterstitial = function () {
            YwTimer.timerADInterstitial = new Date().getTime();
        };
        YwTimer.recordADSplash = function () {
            YwTimer.timerADSplash = new Date().getTime();
        };
        YwTimer.recordADVideo = function () {
            YwTimer.timerADVideo = new Date().getTime();
        };
        YwTimer.recordADInterstitialVideo = function () {
            YwTimer.timerADInterstitialVideo = new Date().getTime();
        };
        // 获取时间差
        YwTimer.getADBanner = function () {
            return new Date().getTime() - YwTimer.timerADBanner;
        };
        YwTimer.getADInterstitial = function () {
            return new Date().getTime() - YwTimer.timerADInterstitial;
        };
        YwTimer.getADSplash = function () {
            return new Date().getTime() - YwTimer.timerADSplash;
        };
        YwTimer.getADVideo = function () {
            return new Date().getTime() - YwTimer.timerADVideo;
        };
        YwTimer.getADInterstitialVideo = function () {
            return new Date().getTime() - YwTimer.timerADInterstitialVideo;
        };
        return YwTimer;
    }());
    YW.YwTimer = YwTimer;
})(YW || (YW = {}));
